﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace sadxsavechecksum
{
    static class Program
    {
        static void Main(string[] args)
        {
            string file;
            if (args.Length > 0)
                file = args[0];
            else
            {
                Console.Write("File: ");
                file = Console.ReadLine();
            }
            byte[] fc = System.IO.File.ReadAllBytes(file);
            BitConverter.GetBytes(CalcSaveChecksum(fc)).CopyTo(fc, 0);
            System.IO.File.WriteAllBytes(file, fc);
        }

        static ushort CalcSaveChecksum(byte[] a2)
        {
            ushort v1; // eax@1
            int v2; // ecx@1
            byte v3; // edi@2
            ushort v4; // eax@3
            ushort v6; // [sp+0h] [bp-4h]@2

            v1 = 65535;
            v2 = 4;
            do
            {
                v3 = a2[v2];
                v6 = (ushort)(v3 ^ v1);
                if (((v3 ^ (byte)v1) & 1) != 0)
                {
                    v4 = (ushort)((v6 >> 1) ^ 0x8408);
                    v6 = (ushort)((v6 >> 1) ^ 0x8408);
                }
                else
                {
                    v4 = (ushort)(v6 >> 1);
                    v6 = (ushort)(v6 >> 1);
                }
                v4 = (ushort)(v4 >> 1);
                if ((v6 & 1) != 0)
                {
                    v4 ^= 0x8408;
                    v6 = v4;
                }
                else
                {
                    v6 = v4;
                }
                v4 = (ushort)(v4 >> 1);
                if ((v6 & 1) != 0)
                {
                    v4 ^= 0x8408;
                    v6 = v4;
                }
                else
                {
                    v6 = v4;
                }
                v4 = (ushort)(v4 >> 1);
                if ((v6 & 1) != 0)
                {
                    v4 ^= 0x8408;
                    v6 = v4;
                }
                else
                {
                    v6 = v4;
                }
                v4 = (ushort)(v4 >> 1);
                if ((v6 & 1) != 0)
                {
                    v4 ^= 0x8408;
                    v6 = v4;
                }
                else
                {
                    v6 = v4;
                }
                v4 = (ushort)(v4 >> 1);
                if ((v6 & 1) != 0)
                {
                    v4 ^= 0x8408;
                    v6 = v4;
                }
                else
                {
                    v6 = v4;
                }
                v4 = (ushort)(v4 >> 1);
                if ((v6 & 1) != 0)
                {
                    v4 ^= 0x8408;
                    v6 = v4;
                }
                else
                {
                    v6 = v4;
                }
                v4 = (ushort)(v4 >> 1);
                if ((v6 & 1) != 0)
                {
                    v1 = (ushort)(v4 ^ 0x8408);
                }
                else
                {
                    v6 = v4;
                    v1 = v6;
                }
                ++v2;
            }
            while (v2 < 0x570);
            return (ushort)~v1;
        }
    }
}